"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _typeof = require("@babel/runtime/helpers/typeof");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.Checkbox = exports.BaseCheckbox = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var _react = _interopRequireWildcard(require("react"));

var _Bool = _interopRequireDefault(require("./Bool"));

var _Checkbox = _interopRequireWildcard(require("./Checkbox.styles"));

var _CheckboxCheckedIcon = _interopRequireDefault(require("./icons/CheckboxCheckedIcon"));

var _CheckboxUncheckedIcon = _interopRequireDefault(require("./icons/CheckboxUncheckedIcon"));

function _getRequireWildcardCache(nodeInterop) { if (typeof WeakMap !== "function") return null; var cacheBabelInterop = new WeakMap(); var cacheNodeInterop = new WeakMap(); return (_getRequireWildcardCache = function _getRequireWildcardCache(nodeInterop) { return nodeInterop ? cacheNodeInterop : cacheBabelInterop; })(nodeInterop); }

function _interopRequireWildcard(obj, nodeInterop) { if (!nodeInterop && obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(nodeInterop); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (key !== "default" && Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

var BaseCheckbox = function BaseCheckbox(_ref) {
  var onChange = _ref.onChange,
      validationState = _ref.validationState,
      checked = _ref.checked,
      props = (0, _objectWithoutProperties2["default"])(_ref, ["onChange", "validationState", "checked"]);

  var _useState = (0, _react.useState)(checked),
      _useState2 = (0, _slicedToArray2["default"])(_useState, 2),
      isChecked = _useState2[0],
      setIsChecked = _useState2[1];

  var icon = /*#__PURE__*/_react["default"].createElement(_CheckboxUncheckedIcon["default"], null);

  if (isChecked) {
    icon = /*#__PURE__*/_react["default"].createElement(_CheckboxCheckedIcon["default"], null);
  }

  function handleChange(event) {
    event.preventDefault();

    if (onChange) {
      onChange(!isChecked);
    }

    setIsChecked(!isChecked);
  }

  return /*#__PURE__*/_react["default"].createElement(_react["default"].Fragment, null, /*#__PURE__*/_react["default"].createElement(_Checkbox["default"], {
    validationState: validationState
  }, props.label), /*#__PURE__*/_react["default"].createElement(_Checkbox.Base, {
    onClick: handleChange
  }, /*#__PURE__*/_react["default"].createElement(_Checkbox.CheckboxView, {
    isChecked: checked
  }, icon)));
};

exports.BaseCheckbox = BaseCheckbox;
BaseCheckbox.propTypes = {
  name: _propTypes["default"].string,
  checked: _propTypes["default"].bool,
  onChange: _propTypes["default"].func,
  validationState: _propTypes["default"].oneOf(['success', 'warning', 'error'])
};
BaseCheckbox.defaultProps = {
  name: 'checkbox',
  checked: false,
  onChange: null,
  validationState: null
};

var Checkbox = function Checkbox(props) {
  return /*#__PURE__*/_react["default"].createElement(_Bool["default"], (0, _extends2["default"])({}, props, {
    componentClass: BaseCheckbox
  }));
};

exports.Checkbox = Checkbox;
var _default = Checkbox;
exports["default"] = _default;
//# sourceMappingURL=Checkbox.js.map